diff --git a/gdb/NEWS b/gdb/NEWS
index 75cd11b204e..f64e0a68c85 100644
--- a/gdb/NEWS
+++ b/gdb/NEWS
@@ -3,6 +3,10 @@
 
 *** Changes since GDB 13
 
+* set debug breakpoints on|off
+  show debug breakpoints
+  Print additional debug messages about breakpoint insertion and removal.
+
 * Multi-target feature configuration
 
   GDB now supports the individual configuration of remote targets' feature
diff --git a/gdb/breakpoint.c b/gdb/breakpoint.c
index 0db3adaf916..1c8a05c6cbd 100644
--- a/gdb/breakpoint.c
+++ b/gdb/breakpoint.c
@@ -163,6 +163,8 @@ static bool bl_address_is_meaningful (bp_location *loc);
 
 static int find_loc_num_by_location (const bp_location *loc);
 
+static std::string breakpoint_location_to_buffer (bp_location *bl);
+
 /* update_global_location_list's modes of operation wrt to whether to
    insert locations now.  */
 enum ugll_insert_mode
@@ -198,6 +200,22 @@ enum ugll_insert_mode
   UGLL_INSERT
 };
 
+static const char *
+ugll_insert_mode_text (ugll_insert_mode insert_mode)
+{
+  switch (insert_mode)
+    {
+    case UGLL_DONT_INSERT:
+      return "UGLL_DONT_INSERT";
+    case UGLL_MAY_INSERT:
+      return "UGLL_MAY_INSERT";
+    case UGLL_INSERT:
+      return "UGLL_INSERT";
+    }
+
+  gdb_assert_not_reached ("must handle all enum values");
+}
+
 static void update_global_location_list (enum ugll_insert_mode);
 
 static void update_global_location_list_nothrow (enum ugll_insert_mode);
@@ -508,6 +526,19 @@ show_always_inserted_mode (struct ui_file *file, int from_tty,
 	      value);
 }
 
+static bool debug_breakpoints = 0;
+
+#define breakpoint_debug_printf(fmt, ...) \
+  debug_prefixed_printf_cond (debug_breakpoints, "breakpoints",fmt,\
+			      ##__VA_ARGS__)
+
+static void
+show_debug_breakpoints (struct ui_file *file, int from_tty,
+			struct cmd_list_element *c, const char *value)
+{
+  gdb_printf (file, _("Breakpoint location debugging is %s.\n"), value);
+}
+
 /* See breakpoint.h.  */
 
 int
@@ -2710,6 +2741,11 @@ insert_bp_location (struct bp_location *bl,
   if (!should_be_inserted (bl) || (bl->inserted && !bl->needs_update))
     return 0;
 
+  breakpoint_debug_printf ("bp_location (%s) at address %s %s",
+			    host_address_to_string (bl),
+			    paddress (bl->gdbarch, bl->address),
+			    breakpoint_location_to_buffer (bl).c_str ());
+
   /* Note we don't initialize bl->target_info, as that wipes out
      the breakpoint location's shadow_contents if the breakpoint
      is still inserted at that location.  This in turn breaks
@@ -3270,6 +3306,8 @@ remove_breakpoints_inf (inferior *inf)
 {
   int val;
 
+  breakpoint_debug_printf ("remove_breakpoints_inf (%d)", inf->num);
+
   for (bp_location *bl : all_bp_locations ())
     {
       if (bl->pspace != inf->pspace)
@@ -3914,6 +3952,13 @@ detach_breakpoints (ptid_t ptid)
 static int
 remove_breakpoint_1 (struct bp_location *bl, enum remove_bp_reason reason)
 {
+  breakpoint_debug_printf ("bp_location (%s) due to %s at address %s %s",
+			   host_address_to_string (bl),
+			   (reason == REMOVE_BREAKPOINT
+			     ? "regular remove" : "detach"),
+			   paddress (bl->gdbarch, bl->address),
+			   breakpoint_location_to_buffer (bl).c_str ());
+
   int val;
 
   /* BL is never in moribund_locations by our callers.  */
@@ -6216,6 +6261,16 @@ print_breakpoint_location (const breakpoint *b,
     }
 }
 
+static std::string
+breakpoint_location_to_buffer (bp_location *bl)
+{
+  string_file stb;
+  current_uiout->redirect (&stb);
+  print_breakpoint_location (bl->owner, bl);
+  current_uiout->redirect (nullptr);
+  return stb.string ();
+}
+
 static const char *
 bptype_string (enum bptype type)
 {
@@ -11146,6 +11201,8 @@ update_global_location_list (enum ugll_insert_mode insert_mode)
   /* Last breakpoint location program space that was marked for update.  */
   int last_pspace_num = -1;
 
+  breakpoint_debug_printf ("%s", ugll_insert_mode_text (insert_mode));
+
   /* Used in the duplicates detection below.  When iterating over all
      bp_locations, points to the first bp_location of a given address.
      Breakpoints and watchpoints of different types are never
@@ -14876,6 +14933,15 @@ when execution stops."),
 				&breakpoint_set_cmdlist,
 				&breakpoint_show_cmdlist);
 
+  add_setshow_boolean_cmd ("breakpoints", class_maintenance,
+			   &debug_breakpoints, _("\
+Set breakpoint location debugging."), _("\
+Show breakpoint location debugging."), _("\
+When non-zero, breakpoint location specific debugging is enabled."),
+			   NULL,
+			   show_debug_breakpoints,
+			   &setdebuglist, &showdebuglist);
+
   add_setshow_enum_cmd ("condition-evaluation", class_breakpoint,
 			condition_evaluation_enums,
 			&condition_evaluation_mode_1, _("\
diff --git a/gdb/doc/gdb.texinfo b/gdb/doc/gdb.texinfo
index 2a2077c29d1..cf33bd351b1 100644
--- a/gdb/doc/gdb.texinfo
+++ b/gdb/doc/gdb.texinfo
@@ -28272,6 +28272,14 @@ debugging info.
 Turn on or off debugging messages for built-in XML parsers.
 @item show debug xml
 Displays the current state of XML debugging messages.
+
+@item set debug breakpoints
+@cindex breakpoint debugging info
+Turns on or off display of @value{GDBN} debugging info for breakpoint insertion
+and removal.  The default is off.
+@item show debug breakpoints
+Displays the current state of displaying @value{GDBN} debugging info for
+breakpoint insertion and removal.
 @end table
 
 @node Other Misc Settings